```
ierr = MPI_Cart_create(old_comm, ndims, dim_size, wrap_around, reorder, &comm2d);
if(ierr != 0) printf("ERROR[%d] creating CART\n",ierr);
    
// find my coordinates in the cartesian communicator group 
MPI_Cart_coords(comm2d, mpi_rank, ndims, coordinates);
printf("I used to be [%d] now I am [%d],[%d]\n",mpi_rank,coordinates[0],coordinates[1]);
    
// Parallellize in two dimensions
// Number of rows and columns in a local world
auto nrows_local = size/(numprocs/2);
auto ncols_local = size/(numprocs/2);
    
printf("size is: [%d]*[%d], local size is: [%d]*[%d] \n",size,size,nrows_local,ncols_local);

    // Create global world
Shape shape_with_ghost_lines = Shape(size + 2, size + 2);
Water water_world = createWater(shape_with_ghost_lines, Shape(size, size), -1,-1);

// Create local world
Shape shape_with_ghost_lines_local = Shape(nrows_local + 2, ncols_local + 2);
Water world_local = createWater(shape_with_ghost_lines_local, Shape(nrows_local, ncols_local), 0, 0);
    
    //uint64_t offset_cols = mpi_rank * rows_local * world_local.shape.cols;
    
uint64_t i_global, j_global, iabs1, iabs2;
for (uint64_t i = 1; i < world_local.shape.rows - 1; ++i) {
    i_global = i + ((coordinates[0]) * nrows_local);
        
    for (uint64_t j = 1; j < world_local.shape.cols - 1; ++j) {
        j_global = j + ((coordinates[1]) * ncols_local);
            
        world_local.e[i * world_local.shape.cols + j] = water_world.e[i_global * water_world.shape.cols + j_global];
        printf("i_local: [%d], j_local: [%d], i_global: [%d], j_global: [%d] \n",i,j,i_global,j_global);
        }
    }
```